\chapter{Theoretical aspects}

We have seen \MCSAT as a proof system and provided some insights on how to implement it.
Given that we employ very similar techniques in our \MCSAT solver as for the regular SMT solver before, it is certainly interesting to compare these two variants.
While we can do so by benchmarking, we may also want to leverage theoretic tools to assess them.
In the following, we compare the proof systems of \MCSAT (from \cref{def:mcsat-proof-system}) and \CDCLST (from \cref{def:cdcl-proof-system}).

The first part is based on the notion of \emph{proof complexity}, roughly following~\cite{Robere2018} -- which relates \CDCLST and \ResST that we define in \cref{def:resolution-theory} -- and our own paper on this issue~\cite{Kremer2019}, relating \MCSAT and \ResST.
The second part then directly compares \CDCLST and \MCSAT, establishing that these two approaches are essentially equivalent.
Both, however, rely on a pretty theoretical view, making rather strong assumptions about the proof systems that usually do not apply to actual implementations, and we discuss these issues as well.
Throughout this work, we can draw some interesting conclusions about the nature of \MCSAT, mostly furthering our intuition, that we present in a final section.
